/**
 * @license minlight.js v0.6.0
 * Updated: Mon Mar 24 2014
 * A minimal lightbox that fades in/out a specified target
 * Copyright (c) 2013 timmy willison
 * Released under the MIT license
 * https://github.com/timmywil/jquery-minlight/blob/master/MIT-LICENSE.txt
 */
!function(a){"function"==typeof define&&define.amd?define(["jquery"],a):a(jQuery)}(function(a){"use strict";var b="__minlight",c=/([A-Z])/g,d=Array.prototype.slice,e=function(d,f){var g=a.data(d,b);if(g)return g;if(!(this instanceof e))return new e(d,f);this.elem=d;var h=this.$elem=a(d);this.options=f=a.extend({},e.defaults,f),a.each(f,function(a){var b=h.attr("data-"+a.replace(c,"-$1").toLowerCase());void 0!==b&&(f[a]=b)}),this.content=f.content,this._setTarget(),this.bind(),this.opened=!1,a.data(d,b,this)};return e.defaults={namespace:".minlight",fadeTime:200,easing:"swing",container:"body",transition:!1,lightboxClass:"lightbox",maskClass:"lightbox-mask",openClass:"lightbox-open",closedClass:"lightbox-closed",closeSelect:"",closeOnMaskClick:!0,expandMask:!0,disableMask:!1,target:"",href:"",imgWidth:"auto",imgHeight:"auto",skeleton:'<div><a href="#" class="lightbox-close" data-bypass="true">X</a></div>'},e.prototype={constructor:e,instance:function(){return this},open:function(a){this._openClose(!1,a)},close:function(a){this._openClose(!0,a)},toggle:function(a){this[this.opened?"close":"open"](a)},bind:function(){var b,c=this.elem,d=this.$elem,e=this.$close,f=this.options,g=f.namespace,h={},i=this;a.each(["Open","Close"],function(){var b=f["on"+this];a.isFunction(b)&&(h["minlight"+this.toLowerCase()+g]=b),b=f["will"+this],a.isFunction(b)&&(h["minlightwill"+this.toLowerCase()+g]=b)}),a.nodeName(c,"a")||a.nodeName(c,"button")?h["click"+g]=function(a){a.preventDefault(),i.toggle()}:void 0!==(b=d.prop("tabIndex"))&&-1!==b&&(h["focus"+g]=function(){i.open(function(){d.blur()})}),a.isEmptyObject(h)||d.on(h),f.closeOnMaskClick&&(e=e.add(this.$mask)),e.on("click"+g,function(a){a.preventDefault(),i.close()})},unbind:function(){this.$elem.add(this.$mask).add(this.$close).off(this.options.namespace)},destroy:function(){this.unbind(),this._removeTarget(),a.removeData(this.elem,b)},option:function(b,c){var d;if(!b)return a.extend({},this.options);if("string"==typeof b){if(void 0===c)return this.options[b];d={},d[b]=c}else d=b;this._setOptions(d)},_setOptions:function(b){var c=this;a.each(b,function(b,d){switch(b){case"container":if(d=a(d),!d.length)return;d.append(c.$mask,c.$target);break;case"imgWidth":case"imgHeight":c.$img&&void 0===c.$elem.attr("data-"+b)&&c.$img[b.replace("img","").toLowerCase()](d);break;case"target":case"disableMask":c._removeTarget();case"closeOnMaskClick":case"namespace":c.unbind()}switch(c.options[b]=d,b){case"fadeTime":case"easing":c.unbind(),c.bind();break;case"target":case"disableMask":c._setTarget();case"closeOnMaskClick":case"namespace":c.bind()}})},_trigger:function(a){var b=d.call(arguments,1);this.$elem.triggerHandler("minlight"+a,b.length?[this].concat(b):[this])},_openClose:function(b,c){function d(){f.opened=!b,b&&e.hide(),c.call(e[0],f),f._trigger(j)}a.isFunction(c)||(c=a.noop);var e=this.$target;if(this.opened^b)return void c.call(e[0],this);var f=this,g=this.options,h=g.fadeTime,i=g.easing,j=b?"close":"open";this._trigger("will"+j),g.transition?(b||e.show(),setTimeout(function(){b?e.removeClass(g.openClass).addClass(g.closedClass):e.removeClass(g.closedClass).addClass(g.openClass)}),setTimeout(d,h)):e.stop()[b?"fadeOut":"fadeIn"](h,i,d),g.disableMask||(!b&&g.expandMask&&this._expandMask(),this.$mask.stop()[b?"fadeOut":"fadeIn"](h,i))},_setTarget:function(){var b,c=this.elem,d=this.$elem,e=this.options,f=e.target,g=a(f);g.length||(a.nodeName(c,"a")||void 0!==(b=d.prop("tabIndex"))&&-1!==b?(null==this.content&&(this.content=this.$img=a("<img>").attr({alt:d.attr("title"),src:e.href||c.href,width:e.imgWidth,height:e.imgHeight})),g=a(e.skeleton).prepend(this.content),g.attr("id",f.replace("#","").replace(/\\/g,""))):g=d),g.length||a.error("minlight - target not found: "+f),g.addClass(e.lightboxClass).data("_minNumAttached",(g.data("_minNumAttached")||0)+1),e.transition&&g.addClass(e.closedClass),a.contains(document,g[0])||g.appendTo(e.container).data("_minAppended",!0),e.disableMask?this.$mask=a():(this.$mask=g.prev("."+e.maskClass.split(" ")[0]),this.$mask.length||(this.$mask=a("<div>").addClass(e.maskClass).insertBefore(g))),this.$target=g,this.$close=g.find(".lightbox-close").add(g.find(e.closeSelect))},_removeTarget:function(){var a=this.$target,b=a.data("_minNumAttached"),c=a.data("_minAppended");(!b||1>=b)&&(c&&a.remove(),this.$mask.remove()),a.data("_minNumAttached",b&&b-1)},_expandMask:function(){var b=a(document).height(),c=a(window).height();this.$mask.height(b>c?b:c)}},a.fn.minlight=function(c){var f,g,h,i;return"string"==typeof c?(i=[],g=d.call(arguments,1),this.each(function(){f=a.data(this,b),f&&"_"!==c.charAt(0)&&"function"==typeof(h=f[c])&&void 0!==(h=h.apply(f,g))&&i.push(h)}),i.length?1===i.length?i[0]:i:this):this.each(function(){new e(this,c)})},e});